#include "aux.h"

int readRequest(void)
{
char caux, *p1, *p2;

reqContentLen=0;
reqContentToRead=0;

err=SSL_read(ssl,req,sizeof(req));
if(err<1) return(-1);
reqReceived=err;
do
	{
	req[reqReceived]=0;
	p1=strstr(req,"\r\n\r\n");
	if(!p1)
		{
	 	timeo.tv_usec=0;
	 	timeo.tv_sec=receive_TO;
  	 	FD_ZERO(&fds);FD_SET(sd,&fds);
  	 	err=select(sd+1,&fds,NULL,NULL,&timeo);
	 	if(err==1)
			{
        		err=SSL_read(ssl,&req[reqReceived],sizeof(req)-reqReceived);
			if(err>0) reqReceived=reqReceived+err;
			}
		else return(-1);
		} 
	}
while(!p1);

p1=p1+4;
reqHeaderLen=p1-req;
caux=*p1; *p1=0;
p2=strstr(req,"ength: ");
*p1=caux;
if(p2)
	{
	p2=p2+7;
	p1=p2; while(*p1 && *p1>32) p1++;
	caux=*p1; *p1=0;
	reqContentLen=atoi(p2); *p1=caux;
	reqContentToRead=reqContentLen+reqHeaderLen-reqReceived;
	}
return(0);
}

void getRequestFields(void)
{

*FIELD_USERNAME=0;
*FIELD_PASSWORD=0;
*FIELD_NEWPASS1=0;
*FIELD_NEWPASS2=0;

aux=strstr(req,"username=");
if(!aux) return;
aux1=aux;while(*aux1 && *aux1!='&') aux1++;
*aux1=0; removePercents(aux);
aux=aux+9; strcpy(FIELD_USERNAME,aux);

aux=aux1+1;
if(strncmp("password=",aux,9)) return;
aux1=aux;while(*aux1 && *aux1!='&') aux1++;
*aux1=0; removePercents(aux);
aux=aux+9; 
strcpy(FIELD_PASSWORD,aux);


aux=aux1+1;
if(strncmp("newpass1=",aux,9)) return;
aux1=aux;while(*aux1 && *aux1!='&') aux1++;
*aux1=0; removePercents(aux);
aux=aux+9;  
if(strlen(aux)<PASSWDD_MINLEN)
	{syslog(LOG_INFO,"newpass1 length too low for user %s",
		FIELD_USERNAME);return;}

strcpy(FIELD_NEWPASS1,aux);

aux=aux1+1;
if(strncmp("newpass2=",aux,9)) return;
aux1=aux;while(*aux1 && *aux1!='&') aux1++;
*aux1=0; removePercents(aux);
aux=aux+9;  
if(strlen(aux)<PASSWDD_MINLEN)
	{syslog(LOG_INFO,"newpass1 length too low for user %s",
		FIELD_USERNAME);return;}
if(strcmp(FIELD_NEWPASS1,aux))
	{syslog(LOG_INFO,"newpass1 and newpass2 are not the same, user %s",
		FIELD_USERNAME);return;}
strcpy(FIELD_NEWPASS2,aux);
}




int writeExact(int fd, char *buff, int todo)
{
int ok;
int c;
c=0;
while(todo)
	{
	ok=write(fd,buff,todo);
	if(ok<0) break;
	if(ok) c=0; else {c++; if(c==3) break; else sleep(1);}
	todo=todo-ok;
	buff=buff+ok;
	}
return(todo);
}


void initSSL(void)
{
SSL_load_error_strings();
OpenSSL_add_ssl_algorithms();
meth = SSLv23_server_method();
ctx = SSL_CTX_new (meth);
if (!ctx)
	{syslog(LOG_NOTICE,"SSL_CTX error");passwddExit(1);}
if (SSL_CTX_use_certificate_file(ctx, CERTF, SSL_FILETYPE_PEM) <= 0) 
	{syslog(LOG_NOTICE,"certificate error");passwddExit(1);}
if (SSL_CTX_use_PrivateKey_file(ctx, KEYF, SSL_FILETYPE_PEM) <= 0)
	{syslog(LOG_NOTICE,"private key error");passwddExit(1);}
if (!SSL_CTX_check_private_key(ctx))
	{syslog(LOG_NOTICE,"private key error");passwddExit(1);}
if (!SSL_CTX_set_cipher_list(ctx,"ALL:@STRENGTH"))
	{syslog(LOG_NOTICE,"cipher error");passwddExit(1);}
ssl = SSL_new (ctx);
}


void passwddExit(int co)
{
if(standAlone)
	{
	if(sock) close(sock);
	if(co) 
		syslog(LOG_INFO,"exiting standalone daemon, code: %i",co);
	}
closelog();
exit(co);
}

void passwddInit(int argc, char **argv)
{
int i;
char *cfile;

cfile=DEF_CONFIG_FILE;
standAlone=0;
sock=sd=0;
/* close(1);
close(2);*/

for(i=1;i<argc;i++)
 {
 if(!strcmp("-D",argv[i])) standAlone=1;
 if(!strcmp("-C",argv[i])) 
	{
	i++;
	if(i<argc) cfile=argv[i];
	}
 }

if(standAlone)
	{
	if(fork()) exit(0);
	}

openlog("passwdd",0,LOG_DAEMON);
initSSL();

readConfig(cfile);

if(standAlone)
	{
	syslog(LOG_INFO,"starting standalone daemon");
	sock=socket(AF_INET,SOCK_STREAM,0);
	setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,&um,sizeof(um));
	bzero((char *)&sa_serv,adl);
	sa_serv.sin_family=AF_INET;
	sa_serv.sin_port=htons(PASSWDD_PORT);
	sa_serv.sin_addr.s_addr=0;
	if(bind(sock,(struct sockaddr *) &sa_serv,adl)== -1)
		{syslog(LOG_NOTICE,"Bind error");passwddExit(1);}
	listen(sock,5);
	}
}


void removePercents(char *line)
{
char *aux=line, *a, c;
int v;

while(*aux)
	{
	while(*aux && *aux!='%') 
		{
		if(*aux=='+') *aux=32;
		aux++;
		}
	if(*aux=='%')
		{
		c=*(aux+3);
		*(aux+3)=0;
		sscanf(aux+1,"%x",&v);
		*aux=v; aux++; *aux=c;
		if(c) {a=aux+1;while(*(a+2)) {*a=*(a+2);a++;} *a=0; *(a+1)=*(a+2)=32;}
		}
	}
}




void readConfig(char *fname)
{
FILE *f;
char line[101], *a;

PASSWDD_PORT=443;
PASSWDD_HTML_FORM=strdup("/usr/local/etc/passwdd_form.html");
PASSWDD_HTML_OK=strdup("/usr/local/etc/passwdd_ok.html");
PASSWDD_HTML_KO=strdup("/usr/local/etc/passwdd_ko.html");
PASSWDD_HTML_SRCNUM=0;
PASSWDD_PAM=strdup("system-auth");
PASSWDD_SEQNUM=0;
PASSWDD_MINLEN=6;
PASSWDD_MINUID=100;

f=fopen(fname,"r");
if(!f) 
	{syslog(LOG_NOTICE,"Failed to open %s",fname);passwddExit(1);}

while(fgets(line,100,f))
  if(*line>='A')
	{
	line[strlen(line)-1]=0;
	if(!strncmp(line,"PORT ",5))
		{
		i=atoi(&line[5]);
		if(i) PASSWDD_PORT=i;
		else
		 syslog(LOG_WARNING,"ignoring PORT option: bad format");
		}
	else
	if(!strncmp(line,"FORM ",5))
		{
		if(!access(&line[5],R_OK))
			{
			free(PASSWDD_HTML_FORM);
			PASSWDD_HTML_FORM=strdup(&line[5]);
			}
		else
		 syslog(LOG_WARNING,"ignoring FORM option: file not found");
		}
	else
	if(!strncmp(line,"OK ",3))
		{
		if(!access(&line[3],R_OK))
			{
			free(PASSWDD_HTML_OK);
			PASSWDD_HTML_OK=strdup(&line[3]);
			}
		else
		 syslog(LOG_WARNING,"ignoring OK option: file not found");
		}
	else
	if(!strncmp(line,"KO ",3))
		{
		if(!access(&line[3],R_OK))
			{
			free(PASSWDD_HTML_KO);
			PASSWDD_HTML_KO=strdup(&line[3]);
			}
		else
		 syslog(LOG_WARNING,"ignoring KO option: file not found");
		}
	else
	if(!strncmp(line,"SRC ",4))
		{
		if(!access(&line[4],R_OK))	
			{
			PASSWDD_HTML_SRC[PASSWDD_HTML_SRCNUM]=strdup(&line[4]);
			PASSWDD_HTML_SRCNUM++;
			}
		else
		 syslog(LOG_WARNING,"ignoring SRC option: file %s not found",
			&line[4]);
		}
	else
	if(!strncmp(line,"PAM ",4))
		{
		free(PASSWDD_PAM);
		PASSWDD_PAM=strdup(&line[4]);
		}
	else
	if(!strncmp(line,"COMMAND ",8))
		{
		a=&line[8]; while(*a && *a!=32) a++;
		if(*a==32) {*a=0; a--;}
		if(!access(&line[8],X_OK))	
		 {
		 line[7]='C';
		 if(*a) {a++;*a=32;}
		 PASSWDD_SEQ[PASSWDD_SEQNUM]=strdup(&line[7]);
		 PASSWDD_SEQNUM++;
		 }
		else
		 syslog(LOG_WARNING,"ignoring COMMAND option: %s not found",
			&line[8]);
		}
	else
	if(!strncmp(line,"MINLEN ",7))
		{
		PASSWDD_MINLEN=atoi(&line[7]);
		if(!PASSWDD_MINLEN) PASSWDD_MINLEN=6;
		else
		 syslog(LOG_WARNING,"ignoring MINLEN option: bad format");
		}
	else
	if(!strncmp(line,"MINUID ",7))
		{
		PASSWDD_MINUID=atoi(&line[7]);
		if(!PASSWDD_MINUID) PASSWDD_MINUID=100;
		else
		 {
		 if(!strcmp(&line[7],"0")) PASSWDD_MINUID=0;
		 else
		  syslog(LOG_WARNING,"ignoring MINUID option: bad format");
		 }
		}
	else
	if(!strncmp(line,"ASKUSER ",8))
		{
		line[7]='U';
		PASSWDD_SEQ[PASSWDD_SEQNUM]=strdup(&line[7]);
		PASSWDD_SEQNUM++;
		}
	else
	if(!strncmp(line,"ASKPASSWD ",10))
		{
		line[9]='P';
		PASSWDD_SEQ[PASSWDD_SEQNUM]=strdup(&line[9]);
		PASSWDD_SEQNUM++;
		}
	else
	if(!strncmp(line,"ASKNEWPASSWD ",13))
		{
		line[12]='N';
		PASSWDD_SEQ[PASSWDD_SEQNUM]=strdup(&line[12]);
		PASSWDD_SEQNUM++;
		}
	else
	if(!strncmp(line,"SAYSUCCESS ",11))
		{
		line[10]='S';
		PASSWDD_SEQ[PASSWDD_SEQNUM]=strdup(&line[10]);
		PASSWDD_SEQNUM++;
		}
	}
fclose(f);
if(PASSWDD_SEQ[0][0]!='C')
	{syslog(LOG_NOTICE,"dialog does not start by COMMAND");passwddExit(1);}
if(PASSWDD_SEQNUM<5)
	{syslog(LOG_NOTICE,"bad dialog for password change");passwddExit(1);}
if(*PASSWDD_SEQ[PASSWDD_SEQNUM-1]!='S')
	{syslog(LOG_NOTICE,"dialog does not end with SUCCESS");passwddExit(1);}
}

void exitSendHtml(char *file)
{

f=fopen(file,"r");

if(!f)	{syslog(LOG_NOTICE,"Failed to open %s",file);passwddExit(1);}
fstat(fileno(f),&fileStat);
l=fileStat.st_size;
err=fread(req,1,l,f);
fclose(f);
if(err!=l) exit(1);
 
sprintf(headerReply,
"%s\r\nConnection: close\r\nContent-Type: text/html\r\nContent-Length: %li\r\n\r\n",nocache,l);
SSL_write (ssl, headerReply, strlen(headerReply));
SSL_write (ssl, req, l);

close(sd);SSL_free(ssl);SSL_CTX_free(ctx);passwddExit(0);
}

void exitSendSource(char *file)
{

f=fopen(file,"r");

if(!f)	{syslog(LOG_NOTICE,"Failed to open %s",file);passwddExit(1);}
fstat(fileno(f),&fileStat);
l=fileStat.st_size;
err=fread(req,1,l,f);
fclose(f);
if(err!=l) exit(1);
 
sprintf(headerReply,
"%s\r\nConnection: close\r\nContent-Length: %li\r\n\r\n",cacheok,l);
SSL_write (ssl, headerReply, strlen(headerReply));
SSL_write (ssl, req, l);

close(sd);SSL_free(ssl);SSL_CTX_free(ctx);passwddExit(0);
}



int runCommand(char *cmd,int *cpid)
{
int master, slave;
char *a, *sname;
struct termios te;
char *vect[50]; int vs;

master=open("/dev/ptmx",O_RDWR,0);
if(master==-1)
	{syslog(LOG_NOTICE,"Failed to open master pty");return(-1);}
grantpt(master);
unlockpt(master);
sname=(char *)ptsname(master);
if(!sname) {close(master);
	syslog(LOG_NOTICE,"Failed to open get slave pty name");return(-1);}

*cpid=fork();
if(*cpid<0) {close(master);
	syslog(LOG_NOTICE,"Failed to fork");return(-1);}

if(!*cpid)
	{
	setsid();
	close(master);
	slave=open(sname,O_RDWR,0);
	if(slave<0)	
		{syslog(LOG_NOTICE,"Failed to open %s",sname);exit(1);}
	if(ioctl(slave,TIOCSCTTY,0)<0)
		{syslog(LOG_NOTICE,"Failed to setup pty");exit(1);}
	if(slave!=0) close(0);
	if(slave!=1) close(1);
	if(slave!=2) close(2);
	dup2(slave,0); dup2(slave,1);dup2(slave,2); 
	if(slave>2) close(slave);
	if(tcgetattr(0,&te)<0)
		{syslog(LOG_NOTICE,"Failed to setup pty");exit(1);}
	te.c_lflag &= ~(ECHO| ECHOE| ECHOK| ECHONL);
	te.c_lflag |= ICANON;
	te.c_lflag &= ~(ONLCR);
	if(tcsetattr(0,TCSANOW,&te)<0)
		{syslog(LOG_NOTICE,"Failed to setup pty");exit(1);}

	syslog(LOG_NOTICE,"starting command %s.",cmd);

 	if(userPw->pw_uid)
		{
		if(setgid(userPw->pw_gid)==-1) exit(1);
		if(setuid(userPw->pw_uid)==-1) exit(1);
		}
 	if(chdir(userPw->pw_dir)==-1) exit(1);
	execl("/bin/sh","sh","-c",cmd,NULL);
	exit(5);
	}
return(master);
}

void readTimeout(int fd, char *buff,int tout)
{
char *a=buff;
int d;
struct timeval to;
fd_set fds;

to.tv_usec=0;
to.tv_sec=tout;
do
	{
	FD_ZERO(&fds);FD_SET(fd,&fds);
	err=select(fd+1,&fds,NULL,NULL,&to);
	if(err==1)
		{
		d=read(fd,a,200);
		if(d<0) break;
		a=a+d;
		}
	}
while(err>0);
*a=0;
}
