#include <pwd.h>
#include <shadow.h>
#include <stdlib.h>
#include <stdio.h>
#include <syslog.h>
#include <termios.h>
#include <unistd.h>
#include <utime.h>
#include <stdlib.h>
#include <memory.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <openssl/rsa.h>
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/err.h>

#define CERTF "/usr/local/etc/passwdd.cert"
#define KEYF  "/usr/local/etc/passwdd.prikey"

#define DEF_CONFIG_FILE "/usr/local/etc/passwdd.conf"

#define receive_TO 10
#define exec_TO 3

unsigned long reqHeaderLen;
unsigned long reqReceived;
unsigned long reqContentLen;
unsigned long reqContentToRead;

char standAlone;

int PASSWDD_PORT;
char *PASSWDD_HTML_FORM;
char *PASSWDD_HTML_OK;
char *PASSWDD_HTML_KO;
char *PASSWDD_HTML_SRC[100];
int PASSWDD_HTML_SRCNUM;
char *PASSWDD_PAM;
char PASSWDD_MINLEN;
int PASSWDD_MINUID;
char *PASSWDD_SEQ[100];
int PASSWDD_SEQNUM;

char FIELD_USERNAME[100];
char FIELD_PASSWORD[100];
char FIELD_NEWPASS1[100];
char FIELD_NEWPASS2[100];

int sock;
static int sd, i, i1, i2, i3, zero=0, um=1, err, alen, pin[2],pout[2];
unsigned long l, l1;
unsigned int ui;
int cliCert;
struct sockaddr_in sa_serv;
struct sockaddr_in sa_cli, from;
struct passwd *userPw;
struct spwd *userPwS;
size_t client_len;
SSL_CTX* ctx;
SSL*  ssl;
X509* client_cert;
char* str;
static int adl=sizeof(sa_serv);


char auth[80], reply[16*1024], headerReply[1024], *aux, *aux1, *aux2, *aux3, *aux4, caux;

char req[16*1024];

static char *nocache="HTTP/1.0 200 Ok\r\nExpires: Thu, 19 Nov 1981 08:50:00 GMT\r\nCache-Control: no-store, no-cache, must-revalidate\r\nPragma: no-cache";

static char *cacheok="HTTP/1.0 200 OK\r\nExpires: Thu, 7 Jan 2020 08:50:00 GMT\r\nCache-Control: store, cache\r\nPragma: cache";

static char *notfound="HTTP/1.0 404 File Not Found\r\nCache-Control: no-store, no-cache, must-revalidate\nPragma: no-cache\r\nContent-type: text/html\r\nConnection: close\r\n\r\n<html><body><h3>Not found or access denied</h3></body></html>";

char hostname[200];
char pservstart[80], requestHandler[200];
char cliName[100], serverPort[10], mainServerPort[10];

unsigned long id1,id2,id3,id4;
SSL_METHOD *meth;
FILE *f;
time_t now;
struct timeval timeo;
fd_set fds;
struct hostent *cliEnt;
struct stat fileStat;
char activeDetect;

int readRequest(void);
void getRequestFields(void);
int writeExact(int fd, char *buff, int todo);
void initSSL(void);
void passwddInit(int argc, char **argv);
void passwddExit(int);
void removePercents(char *line);
void readConfig(char *file);
void exitSendHtml(char *file);
int runCommand(char *cmd, int *cpid);
void readTimeout(int fd, char *buff, int tout);



