#include "aux.h"
#include "auth_pam.h"

void terminate(int a)
{
syslog(LOG_WARNING,"received TERM signal");
passwddExit(1);
}

void chld_done(int a)
{
wait(&a);
signal(SIGCHLD,chld_done);
}

int main (int argc, char **argv)
{
FILE *pp;
int cli_pid,rc;

passwddInit(argc,argv);

if(standAlone)
   {
   signal(SIGCHLD,chld_done);
   signal(SIGTERM,terminate);
   signal(SIGHUP,terminate);
   while(1)
	{
	sd=accept(sock,(struct sockaddr *)&sa_cli,&adl);
	if(sd>0)
		{
		if(!fork()) break;
		close(sd);
		}
	}
   }

if(standAlone) 
	{
	close(sock);
	}
SSL_set_fd(ssl,sd);
err=SSL_accept(ssl);

err=readRequest();

if(err==-1) 
	{close(sd);SSL_free(ssl);SSL_CTX_free(ctx);
	syslog(LOG_WARNING,"receive error");
	passwddExit(1);}

i1=reqContentToRead;
while(i1)
	{
 	timeo.tv_usec=0;
 	timeo.tv_sec=receive_TO;
 	FD_ZERO(&fds);FD_SET(sd,&fds);
 	err=select(sd+1,&fds,NULL,&fds,&timeo);
 	if(err==1)
		{
		if(i1>(sizeof(req)-reqReceived)) i2=sizeof(req)-reqReceived; else i2=i1;
		if(i2<=0) break;
       		err=SSL_read(ssl,&req[reqReceived],i2);
		if(err==-1) break;
		if(err>0) {i1=i1-err;reqReceived=reqReceived+err;}
		}
	else break;
	}



getRequestFields();

if( !*FIELD_NEWPASS2)
	{
	aux=req;
	while(*aux!='\n' && strncmp(aux,"POST",4)) aux++;
	if(*aux!='\n')
		{exitSendHtml(PASSWDD_HTML_KO);}

	/* no data, send html form or other source file and exit */
	for(i=0;i<PASSWDD_HTML_SRCNUM;i++)
		{
		aux1=aux=PASSWDD_HTML_SRC[i];
		while(*aux1) aux1++;
		while(aux1>aux && *aux1!='/') aux1--;
		aux=req;
		while(*aux!='\n' && strncmp(aux,aux1,strlen(aux1))) aux++;
		if(*aux!='\n')
			{
			exitSendSource(PASSWDD_HTML_SRC[i]);
			}
		}
	exitSendHtml(PASSWDD_HTML_FORM);
	}

userPw=getpwnam(FIELD_USERNAME);
if(!userPw)
	{ syslog(LOG_WARNING,"failed to get user %s account",FIELD_USERNAME);
	exitSendHtml(PASSWDD_HTML_KO);}

if(!auth_pam(FIELD_USERNAME,FIELD_PASSWORD,PASSWDD_PAM))
	{ syslog(LOG_WARNING,"user %s authentication failed",FIELD_USERNAME);
	exitSendHtml(PASSWDD_HTML_KO);}

if(userPw->pw_uid<PASSWDD_MINUID)
	{ syslog(LOG_WARNING,"user %s UID is too low",FIELD_USERNAME);
	exitSendHtml(PASSWDD_HTML_KO);}

rc=-1;
for(i=0;i<PASSWDD_SEQNUM;i++)
 {
 if(*PASSWDD_SEQ[i]=='C')
	{
        if(rc!=-1)
	 {
	 close(rc);
	 wait(NULL);
	 }
 	rc=runCommand(&PASSWDD_SEQ[i][1],&cli_pid);
 	if(rc==-1)
	  { syslog(LOG_WARNING,"failed to run the external command %s",
	  &PASSWDD_SEQ[i][1]);
	  exitSendHtml(PASSWDD_HTML_KO);}
	}
 else
	{
	readTimeout(rc,reply,5);
	if(!strstr(reply,&PASSWDD_SEQ[i][1]))
	 {
	 close(rc);
	 kill(cli_pid,SIGKILL);
	 wait(&i);
   	 syslog(LOG_WARNING,
	       "user %s failed to change password, waiting for %s, received %s",
		FIELD_USERNAME,PASSWDD_SEQ[i],reply);
	 exitSendHtml(PASSWDD_HTML_KO);
	 }
	aux1=0;
	switch(*PASSWDD_SEQ[i])
	 {
	 case 'U': aux1=FIELD_USERNAME; break;
	 case 'P': aux1=FIELD_PASSWORD; break;
	 case 'N': aux1=FIELD_NEWPASS1; break;
	 case 'S': break;
	 }
	if(aux1)
	 {
	 if(write(rc,aux1,strlen(aux1))!=strlen(aux1))
   	   syslog(LOG_WARNING,"error writting data to pty");
	 write(rc,"\n",1);
	 }
	}
 }

close(rc);
if(i!=PASSWDD_SEQNUM)
	{
	kill(cli_pid,SIGKILL);
	wait(&i);
   	syslog(LOG_WARNING,"user %s failed to change password",
		FIELD_USERNAME);
	exitSendHtml(PASSWDD_HTML_KO);
	}
else
	{
	wait(&i);
   	syslog(LOG_WARNING,"user %s password changed",FIELD_USERNAME);
	exitSendHtml(PASSWDD_HTML_OK);
	}

close(sd);SSL_free(ssl);SSL_CTX_free(ctx);exit(0);
}








